unit mutexhandling;

interface
uses
  Windows;

  function CheckForMutex(var sMutex :HWND):Boolean;

implementation

//note, must always be called within a wrapped try/finally with releasemutex
//if mutex is not zero, then false is returned and tests not run

function CheckForMutex(var sMutex :HWND):Boolean;
begin

Result := False;

try
  if sMutex = 0 then
    begin
      sMutex := CreateMutex(nil, false, 'MyApplication Mutex');
      case (WaitForSingleObject(sMutex, 0)) of
        WAIT_OBJECT_0:  //we own it
          Result := True;
      else
        //WAIT_TIMEOUT:;   //someone else owns it
        //WAIT_ABANDONED:; //we gave up
        //WAIT_FAILED:    //something went wrong
          Result := False;
      end;  //case of
    end;//if sMutex <> 0
except //safety net...
    Result := False; //note, should really check for not true state...Delphi???
  end;  //finally
end;


end.
